package net.udby.test.sdf;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;

public class DateFormatUtilCreate {

	private DateFormatUtilCreate() {
	}

	public static String format(Date date, String formatString, Locale locale, TimeZone timeZone) {
		SimpleDateFormat sdf = new SimpleDateFormat(formatString, locale);
		sdf.setTimeZone(timeZone);
		return sdf.format(date);
	}

	public static String format(Date date, String formatString, Locale locale) {
		return new SimpleDateFormat(formatString, locale).format(date);
	}

	public static String format(Date date, String formatString) {
		return new SimpleDateFormat(formatString).format(date);
	}

	public static Date parse(String date, String formatString, Locale locale, TimeZone timeZone) throws ParseException {
		SimpleDateFormat sdf = new SimpleDateFormat(formatString, locale);
		sdf.setTimeZone(timeZone);
		return sdf.parse(date);
	}

	public static Date parse(String date, String formatString, Locale locale) throws ParseException {
		return new SimpleDateFormat(formatString, locale).parse(date);
	}

	public static Date parse(String date, String formatString) throws ParseException {
		return new SimpleDateFormat(formatString).parse(date);
	}
}
