package net.udby.test.sdf;

import java.io.PrintWriter;

import net.udby.test.sdf.wrapper.stat.StatInfo;

public class ReportGenerator {
	private final PrintWriter pw;

	public ReportGenerator(PrintWriter pw) {
		this.pw = pw;
	}

	public ReportGenerator headline(String headline) {
		pw.println(headline);
		return this;
	}

	public ReportGenerator emptyline() {
		return headline("");
	}

	public ReportGenerator statHeadline(Class<?> clazz, int cnt, long runtime, long relaxtime) {
		pw.printf(";\"class\";\"method\";\"count\";\"min (ns)\";\"max (ns)\";\"avg\";;%n");
		pw.printf(";\"%s\";;;;;;\"threads=%d, runtime(ms)=%d, relaxtime(ms)=%d\";%n", clazz.getName(), cnt, runtime, relaxtime);
		return this;
	}

	public ReportGenerator statline(StatInfo si) {
		pw.printf(";;\"%s\";%d;%d;%d;%e%n", si.methodSignature, si.getCount(), si.getMinTimeNs(), si.getMaxTimeNs(), si.getAverage());
		return this;
	}

	public ReportGenerator failline(String msg) {
		pw.printf(";;\"%s\";;;;%n", msg);
		return this;
	}
}
