package net.udby.test.sdf;

import java.text.SimpleDateFormat;
import java.util.Date;

public class ThreadingError {
	/**
	 * The not-thread-safe static SimpleDateFormat instance misused for the test...
	 */
	private static final SimpleDateFormat staticInstance = new SimpleDateFormat("yyyyMMddHHmmssSSS");
	private static final int THREAD_COUNT = 2;

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		final Exception[] exc = new Exception[THREAD_COUNT];
		Thread[] threads = new Thread[THREAD_COUNT];
		for (int i = 0; i < THREAD_COUNT; i++) {
			final int idx = i;
			threads[idx] = new Thread() {
				public void run() {
					try {
						long t0 = System.currentTimeMillis();
						while ((System.currentTimeMillis() - t0) < 10000l) {
							Date date = new Date();
							String s = staticInstance.format(date);
							Date tst = staticInstance.parse(s);
							if (!date.equals(tst)) {
								throw new Exception("Date error. expected=" + date + ", was=" + tst);
							}
							String ss = staticInstance.format(date);
							if (!ss.equals(s)) {
								throw new Exception("Date error. expected=" + s + ", was=" + ss);
							}
						}
					} catch (Exception e) {
						exc[idx] = e;
					}
				}
			};
			threads[idx].start();
		}
		for (Thread thread : threads) {
			thread.join();
		}
		boolean failed = false;
		for (int i = 0; i < exc.length; i++) {
			if (exc[i] != null) {
				System.out.println("--------------------------------");
				exc[i].printStackTrace(System.out);
				failed = true;
			}
		}
		if (!failed) {
			System.out.println("OK!");
		}
	}
}
