package net.udby.test.sdf.simple;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class SdfSimpleSync {
	public static final String FORMAT_1 = "dd-MM-yyyy HH:mm:ss";

	private static final SimpleDateFormat sdf = new SimpleDateFormat(FORMAT_1);

	public static String format(Date date) {
		synchronized (sdf) {
			return sdf.format(date);
		}
	}

	public static Date parse(String s) throws ParseException {
		synchronized (sdf) {
			return sdf.parse(s);
		}
	}

	public static class Factory implements SimpleApi {
		@Override
		public Date parse(String s) throws ParseException {
			return SdfSimpleSync.parse(s);
		}

		@Override
		public String format(Date date) {
			return SdfSimpleSync.format(date);
		}
	}
}
