package net.udby.test.sdf.simple;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class SdfSimpleThreadLocal {
	public static final String FORMAT_1 = "dd-MM-yyyy HH:mm:ss";

	private static final ThreadLocal<SimpleDateFormat> holder = new ThreadLocal<SimpleDateFormat>() {
		@Override
		protected SimpleDateFormat initialValue() {
			return new SimpleDateFormat(FORMAT_1);
		}
	};

	public static String format(Date date) {
		return holder.get().format(date);
	}

	public static Date parse(String s) throws ParseException {
		return holder.get().parse(s);
	}

	public static class Factory implements SimpleApi {
		@Override
		public Date parse(String s) throws ParseException {
			return SdfSimpleThreadLocal.parse(s);
		}

		@Override
		public String format(Date date) {
			return SdfSimpleThreadLocal.format(date);
		}
	}
}
