package net.udby.test.sdf.wrapper.stat;

public class StatInfo {
	public final String methodSignature;
	private int count;
	private long minTimeNs;
	private long maxTimeNs;
	private long accumTimeNs;

	private StatInfo(String methodSignature) {
		this.methodSignature = methodSignature;
	}

	public StatInfo(String methodSignature, long timeNs) {
		super();
		this.methodSignature = methodSignature;
		this.count = 1;
		this.minTimeNs = timeNs;
		this.maxTimeNs = timeNs;
		this.accumTimeNs = timeNs;
	}

	public void add(long timeNs) {
		this.count++;
		this.accumTimeNs += timeNs;
		if (timeNs < minTimeNs) {
			this.minTimeNs = timeNs;
		} else if (timeNs > maxTimeNs) {
			this.maxTimeNs = timeNs;
		}
	}

	public static StatInfo consolidate(StatInfo a, StatInfo b) {
		StatInfo result = new StatInfo(b.methodSignature);
		result.accumTimeNs = a.accumTimeNs + b.accumTimeNs;
		result.count = a.count = b.count;
		result.minTimeNs = Math.min(a.minTimeNs, b.minTimeNs);
		result.maxTimeNs = Math.max(a.maxTimeNs, b.maxTimeNs);
		return result;
	}

	public int getCount() {
		return count;
	}

	public long getMinTimeNs() {
		return minTimeNs;
	}

	public long getMaxTimeNs() {
		return maxTimeNs;
	}

	public long getAccumTimeNs() {
		return accumTimeNs;
	}

	@Override
	public String toString() {
		return "StatInfo [methodSignature=" + methodSignature + ", count=" + count + ", minTimeNs=" + minTimeNs + ", maxTimeNs="
				+ maxTimeNs + ", accumTimeNs=" + accumTimeNs + ", avg=" + getAverage() + "]";
	}

	public double getAverage() {
		return (1e-9 * accumTimeNs / count);
	}
}
